using System; 
using System.Diagnostics; 

class Favorite 
{ 
  protected string name; 
  protected Uri url; 

  public Favorite(string name, Uri url) 
  { 
    this.name = name; 
    this.url = url; 
  } 

  public virtual void Open() 
  { 
    Process.Start(url.ToString()); 
  } 
} 

class Favorite2 : Favorite 
{ 
  DateTime dateTime; 
  int i; 

  public Favorite2(string name, Uri url) 
    : base(name, url) 
  { 
    dateTime = DateTime.Now; 
    i = 0; 
  } 

  public override void Open() 
  { 
    ++i; 
    Console.Out.WriteLine(i); 
    Process.Start(url.ToString()); 
  } 
} 

class Program 
{ 
  static void Open(Favorite fav) 
  { 
    fav.Open(); 
  } 

  static void Main(string[] args) 
  { 
    var favHighscore = new Favorite2("Highscore - Programmieren lernen", new Uri("http://www.highscore.de/")); 
    Open(favHighscore); 
  } 
} 