using System; 
using System.Diagnostics; 

class Favorite 
{ 
  protected string name; 
  protected Uri url; 

  public Favorite(string name, Uri url) 
  { 
    this.name = name; 
    this.url = url; 
  } 

  public string Name 
  { 
    get { return name; } 
  } 

  public virtual void Open() 
  { 
    Process.Start(url.ToString()); 
  } 
} 

class Favorite2 : Favorite, IComparable 
{ 
  DateTime dateTime; 
  int i; 

  public Favorite2(string name, Uri url, int i) 
    : base(name, url) 
  { 
    this.i = i; 
    dateTime = DateTime.Now; 
  } 

  public override void Open() 
  { 
    ++i; 
    Process.Start(url.ToString()); 
  } 

  public int CompareTo(object obj) 
  { 
    Favorite2 fav = (Favorite2)obj; 
    if (fav.i > i) 
      return 1; 
    else if (fav.i < i) 
      return -1; 
    else 
      return 0; 
  } 
} 

class Program 
{ 
  static void Main(string[] args) 
  { 
    Favorite2[] favs = 
    { 
      new Favorite2("Highscore - Programmieren lernen", new Uri("http://www.highscore.de/"), 10), 
      new Favorite2("Microsoft Deutschland GmbH", new Uri("http://www.microsoft.de/"), 5), 
      new Favorite2("Microsoft .NET Framework ", new Uri("http://www.microsoft.de/NET/"), 20) 
    }; 

    Array.Sort(favs); 
    Console.Out.WriteLine(favs[0].Name); 
  } 
} 