using System; 
using System.Diagnostics; 

public class FavoriteManager 
{ 
  Favorite[] favs; 

  public event EventHandler FavoriteAdded; 

  public FavoriteManager() 
  { 
    FavoriteAdded += new EventHandler(OnFavoriteAdded); 
    FavoriteAdded += delegate(Object sender, EventArgs e) { Trace.WriteLine("Favorite added"; }; 
    FavoriteAdded += (sender, e) => { Trace.WriteLine("Favorite added"); }; 
  } 

  public void Add(string name, string url) 
  { 
    if (favs == null) 
    { 
      favs = new Favorite[] { new Favorite(name, new Uri(url)) }; 
    } 
    else 
    { 
      Favorite[] favs2 = new Favorite[favs.Length + 1]; 
      Array.Copy(favs, favs2, favs.Length); 
      favs2[favs.Length] = new Favorite(name, new Uri(url)); 
      favs = favs2; 
    } 

    if (FavoriteAdded != null) 
    { 
      FavoriteAdded(this, EventArgs.Empty); 
    } 
  } 

  void OnFavoriteAdded(Object sender, EventArgs e) 
  { 
    Trace.WriteLine("Favorite added"); 
  } 
} 