using System; 
using System.Collections.Generic; 

public class FavoriteManager<TFavorite> 
  where TFavorite : Favorite, new() 
{ 
  List<TFavorite> favs = new List<TFavorite>(); 

  public void Add(string name, string url) 
  { 
    TFavorite fav = new TFavorite(); 
    fav.Name = name; 
    fav.URL = new Uri(url); 
    favs.Add(fav); 
  } 

  public TFavorite[] Favorites 
  { 
    set 
    { 
      favs.Clear(); 
      favs.AddRange(value); 
    } 

    get { return favs.ToArray(); } 
  } 
} 